import { Asset, Assets } from '../../../types';
import DefaultAPIHandler from './default';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
                minLength: number;
                pattern: string;
            };
        };
        required: string[];
    };
};
export type Client = {
    client_id: string;
    name: string;
    custom_login_page?: string;
    custom_login_page_on?: boolean;
};
export default class ClientHandler extends DefaultAPIHandler {
    existing: Asset[] | null;
    constructor(config: DefaultAPIHandler);
    objString(item: any): string;
    processChanges(assets: Assets): Promise<void>;
    getType(): Promise<Asset[]>;
}
